package org.one.stone.soup.grfx;

import java.awt.*;
import java.awt.image.*;

import org.one.stone.soup.math.*;

/*
 * Wet-Wired.com Library Version 2.1
 *
 * Copyright 2000-2001 by Wet-Wired.com Ltd.,
 * Portsmouth England
 * This software is OSI Certified Open Source Software
 * This software is covered by an OSI approved open source licence
 * which can be found at http://www.onestonesoup.org/OSSLicense.htmlhttp://www.onestonesoup.org/OSSLicense.html
 */

/**
 * @author nikcross
 *
 */

public class ImageRotator{

public static Image filter(Image image,Component owner,int rotation) {

	int w = image.getWidth(owner);
	int h = image.getHeight(owner);
	int scan = w;
	int size = w*h;
	int[] data = new int[size];

	PixelGrabber pGrab = new PixelGrabber(image,0,0,w,h,data,0,scan);
	try{pGrab.grabPixels();}catch(Exception e){}

	int[] newData = new ImageRotator().process(data,w,h,rotation);

	w=IntMath.distance(w,h);
	h=w;
	scan = w;

	MemoryImageSource mis = new MemoryImageSource(w,h,newData,0,scan);

	return owner.getToolkit().createImage(mis);
}
public int[] process(int[] data, int w, int h,int r) {

	r=-r;

	// calc size of result image
	int nW=IntMath.distance(w,h);
	int nH=nW;

	// calc mid point of original
	int x2 = w/2;
	int y2 = h/2;

	// generate result container
	int[] result = new int[nW*nH];

	// calc mid point of result
	int x = nW/2;
	int y = nH/2;

	// result x,y
	int rX;
	int rY;

	// original x,y
	int loopX;
	int loopY;

	// data pointer
	int pos=0;

/*	if(x%2!=0)
	{
		x++;
	}*/

	for(loopY=-y;loopY<y;loopY++)
	{
		for(loopX=-x;loopX<x;loopX++)
		{
			if(pos>=result.length)
				return result;

			rX = IntMath.cos(r,loopX)-IntMath.sin(r,loopY)+x2;
			rY = IntMath.sin(r,loopX)+IntMath.cos(r,loopY)+y2;


			if( rX>0 && rX<w && rY>0 && rY<h)
			{
				result[pos] = data[rX+(rY*w)];
			}
			else
			{
				result[pos] = 0;
			}


			pos++;
		}
	}

	return result;
}
}
