package org.one.stone.soup.mjdb.data.functions;

import org.one.stone.soup.mjdb.data.field.*;
import org.one.stone.soup.mjdb.data.group.*;

/*
 * MJDB (Micro Java Database) Version 1.0
 *
 * Copyright 2000-2001 by Wet-Wired.com Ltd.,
 * Portsmouth England
 * This software is OSI Certified Open Source Software
 * This software is covered by an OSI approved open source licence
 * which can be found at http://www.wet-wired.com/licence/license-os.html
 */

public final class Search {
public static int count(Table target,String data) throws SearchException{

	int result = 0;

	int loopC;
	int loopR;

	try{
		for(loopR=0;loopR<target.getNoOfRows();loopR++)
		{
			for(loopC=0;loopC<target.getNoOfColumns();loopC++)
			{
				if(target.getField(loopC,loopR) instanceof String)
				{
					if( ((String)target.getField(loopC,loopR)).indexOf(data) != -1)
					{
						loopC=target.getNoOfColumns();
						result++;
						break;
					}
				}
			}
		}

		return result;
	}
	catch(Exception e)
	{
		throw new SearchException("count:"+e);
	}
}
public static Index find(Table target,String data) throws SearchException,DatabaseException{

	Index result = new Index();

	int loopC;
	int loopR;
	boolean found=false;

	for(loopR=0;loopR<target.getNoOfRows();loopR++)
	{
		for(loopC=0;loopC<target.getNoOfColumns();loopC++)
		{
			if(target.getField(loopC,loopR) instanceof String)
			{
				if( ((String)target.getField(loopC,loopR)).indexOf(data) != -1)
				{
					try{
						result.setValue(loopR,null);
					}
					catch(Exception e)
					{
						throw new SearchException("find: "+e);
					}
					found=true;
					break;
				}
			}
			if(found)
				break;
		}
		if(found)
			break;
	}

	return result;
}
public static Table search(Table target,int loopC,Object data) throws CompareException,DatabaseException{

	return search(target,loopC,(Field)Wrapper.wrap(data));

}
public static Table search(Table target,int loopC,Field data) throws CompareException,DatabaseException{

	Table result = new Table(target.getNoOfColumns());

	for(int loopD=0;loopD<target.getNoOfColumns();loopD++)
	{
		try{
			result.setColumnTitle(loopD,target.getColumnTitle(loopD),null);
		}
		catch(Exception e)
		{
			System.out.println("search failed to set column title");
		}
	}

	int loopR;

	for(loopR=0;loopR<target.getNoOfRows();loopR++)
	{
		if(target.getField(loopC,loopR) instanceof Field)
		{
			if( ((Field)target.getField(loopC,loopR)).compare(data) == Field.EQ)
			{
				try{
					result.addRow(target.getRow(loopR),result);
				}
				catch(LockException le)
				{
					//ignore
				}
			}
		}
		else
			throw new CompareException("Can't compare "+data+" of type "+data.getClass()+" with "+target.getField(loopC,loopR)+" of type "+target.getField(loopC,loopR).getClass());
	}

	return result;
}
public static Table search(Table target,Object data) throws CompareException,DatabaseException{

	return search(target,(Field)Wrapper.wrap(data));

}
public static Table search(Table target,String columnName,Object data) throws CompareException,DatabaseException{
	return search(target,columnName,(Field)Wrapper.wrap(data));
}
public static Table search(Table target,String columnName,Object min,Object max) throws CompareException,DatabaseException{
	return search(target,columnName,(Field)Wrapper.wrap(min),(Field)Wrapper.wrap(max));
}
public static Table search(Table target,String columnName,Field data) throws CompareException,DatabaseException{

	Table result = new Table(target.getNoOfColumns());

	int loopR;
	int loopC;

	//System.out.println("Searching "+columnName+" for "+data);

	for(loopC=0;loopC<target.getNoOfColumns();loopC++)
	{
		try{
			result.setColumnTitle(loopC,target.getColumnTitle(loopC),null);
		}
		catch(Exception e)
		{
			System.out.println("search failed to set column title");
		}
	}

	for(loopC=0;loopC<target.getNoOfColumns();loopC++)
	{
		if(target.getColumnTitle(loopC) instanceof String)
		{
			//System.out.println("Found col:"+((String)target.getColumnTitle(loopC))+" =? "+columnName);
			if(((String)target.getColumnTitle(loopC)).equals(columnName))
			{
				//System.out.println("Col match:"+loopC);
				break;
			}
		}
	}

	for(loopR=0;loopR<target.getNoOfRows();loopR++)
	{
		if(target.getField(loopC,loopR) instanceof Field)
		{
			//System.out.println(target.getField(loopC,loopR)+"="+data);
			if( ((Field)target.getField(loopC,loopR)).compare(data) == Field.EQ)
			{
				try{
					result.addRow(target.getRow(loopR),result);
				}
				catch(LockException le)
				{
					//ignore
				}
			}
		}
		else
			throw new CompareException("Can't compare "+data.getClass()+" with "+target.getField(loopC,loopR).getClass());
	}

	return result;
}
public static Table search(Table target,String columnName,Field min,Field max) throws CompareException,DatabaseException{

	Table result = new Table(target.getNoOfColumns());

	int loopR;
	int loopC;

	//System.out.println("Searching "+columnName+" for range "+min+" to "+max);

	for(loopC=0;loopC<target.getNoOfColumns();loopC++)
	{
		try{
			result.setColumnTitle(loopC,target.getColumnTitle(loopC),null);
		}
		catch(Exception e)
		{
			System.out.println("search failed to set column title");
		}
	}

	for(loopC=0;loopC<target.getNoOfColumns();loopC++)
	{
		if(target.getColumnTitle(loopC) instanceof String)
		{
			//System.out.println("Found col:"+((String)target.getColumnTitle(loopC))+" =? "+columnName);
			if(((String)target.getColumnTitle(loopC)).equals(columnName))
			{
				//System.out.println("Col match:"+loopC);
				break;
			}
		}
	}

	for(loopR=0;loopR<target.getNoOfRows();loopR++)
	{
		if(target.getField(loopC,loopR) instanceof Field)
		{
			//System.out.println(target.getField(loopC,loopR)+"="+data);
			if( ((Field)target.getField(loopC,loopR)).inRange(min,max) == true)
			{
				try{
					result.addRow(target.getRow(loopR),target);
				}
				catch(LockException le)
				{
					//ignore
				}
			}
		}
		else
			throw new CompareException("Can't compare "+min+"="+max+" with "+target.getField(loopC,loopR).getClass());
	}

	return result;
}
public static Table search(Table target,Field data) throws CompareException,DatabaseException{

	Table result = new Table(target.getNoOfColumns());

	int loopC;
	int loopR;

	for(loopC=0;loopC<target.getNoOfColumns();loopC++)
	{
		try{
			result.setColumnTitle(loopC,target.getColumnTitle(loopC),null);
		}
		catch(Exception e)
		{
			System.out.println("search failed to set column title");
		}
	}

	for(loopR=0;loopR<target.getNoOfRows();loopR++)
	{
		for(loopC=0;loopC<target.getNoOfColumns();loopC++)
		{
			if(target.getField(loopC,loopR) instanceof Field)
			{
				try{
					if( ((Field)target.getField(loopC,loopR)).compare(data) == Field.EQ)
					{
						result.addRow(target.getRow(loopR),result);
						loopC=target.getNoOfColumns();
						break;
					}
				}
				catch(LockException le)
				{
					//ignore
				}
				catch(CompareException ce)
				{
					//ignore
				}
			}
//			else
//				throw new CompareException("Can't compare "+data+" with "+target.getField(loopC,loopR));
		}
	}

	return result;
}
}
