package org.one.stone.soup.mjdb.data.group;

import org.one.stone.soup.mjdb.data.field.*;
import org.one.stone.soup.mjdb.data.functions.*;

/*
 * MJDB (Micro Java Database) Version 1.0
 *
 * Copyright 2000-2001 by Wet-Wired.com Ltd.,
 * Portsmouth England
 * This software is OSI Certified Open Source Software
 * This software is covered by an OSI approved open source licence
 * which can be found at http://www.wet-wired.com/licence/license-os.html
 */

public class LinkSet extends Table{
	public static int TABLE_A = 0;
	public static int COLUMN_A= 1;
	public static int TABLE_B = 2;
	public static int COLUMN_B= 3;
	public static int LINK_ROW= 4;
	public static int COLUMNS= 5;

	private int columnCount=0;
	private Row row;



public LinkSet() {
	super(6);
}
public int getColumnCount() {
	return columnCount;
}
/**
 * getValue method comment.
 */
public String getValue(String name) {
	return null;
}
public void join(int row) throws JoinException{

 try{

	for(int loop=0;loop<getNoOfRows()-1;loop++)
	{
		Table tableA = (Table)getField(TABLE_A,loop);
		int columnA = ((IntField)getField(COLUMN_A,loop)).getValue();
		Field fieldA = (Field)tableA.getField(columnA,row);

		Table tableB = (Table)getField(TABLE_B,loop);
		int columnB = ((IntField)getField(COLUMN_B,loop)).getValue();

		Table linkTable = Search.search(tableB,columnB,fieldA);

		try{
			tableA.setField(LINK_ROW,linkTable.getRow(loop),this);
		}
		catch(LockException e)
		{
			throw new JoinException("join:"+e);
		}
		catch(SetException e)
		{
			throw new JoinException("join:"+e);
		}
	}

 }
 catch(Exception e)
 {
	 System.out.println("Join error "+e);
 }
}

public void addLink(int columnA, Table tableB, int columnB,ColumnSet columns,Object source) throws LockException,SetException{

	row.setField(COLUMN_A,new IntField(columnA),this);
	row.setField(TABLE_B,tableB,this);
	row.setField(COLUMN_B,new IntField(columnB),this);
	row.setField(COLUMNS,columns,this);

	row = addRow(source);
	if(report)
		reportChange(source);
}

public void setController(Table tableA,Object source) throws SetException,LockException{

	Row row = addRow(source);

	row.setField(TABLE_A,tableA,source);
}

public void setController(Table tableA,ColumnSet columns,Object source) throws LockException,SetException{

	Row row = addRow(source);

	row.setField(TABLE_A,tableA,source);
	row.setField(COLUMNS,columns,source);
	columnCount+=columns.getNoOfRows();
}
}
