package org.one.stone.soup.xapp.components.form;

import org.one.stone.soup.xml.XmlElement;
import org.one.stone.soup.xml.helper.XmlCloner;
import org.one.stone.soup.xml.helper.XmlTraverser;

public class XFormHelper {

	public static XmlElement createDataForForm()
	{
		return new XmlElement("data");
	}
	
	public static void addValueToFormData(XmlElement data,String key,String value)
	{
		data.addChild( key ).addValue( value );
	}
	
	public static void addForm(XmlElement targetForm,XmlElement formToAdd)
	{
		formToAdd = XmlCloner.getClone(formToAdd);
		String prefix = formToAdd.getAttributeValueByName("name")+".";
		
		XmlTraverser traverser = new XmlTraverser(formToAdd);
		while(traverser.hasMoreElements())
		{
			XmlElement element = traverser.nextElement();
			if(element.getAttributeValueByName("name")!=null)
			{
				element.setAttributeValue("name",prefix+element.getAttributeValueByName("name"));
			}
		}		
		
		for(int loop=0;loop<formToAdd.getElementCount();loop++)
		{
			targetForm.addChild(formToAdd.getElementByIndex(loop));
		}
	}
}
