package org.one.stone.soup.xapp.plugins;

import java.util.Properties;

import org.one.stone.soup.xapp.XappPlugin;
import org.one.stone.soup.xapp.factories.XappMenuFactory;
import org.one.stone.soup.xapp.factories.XappPluginFactory;
import org.one.stone.soup.xml.XmlElement;

public class ProxyPlugin extends XappPlugin {
	
	public ProxyPlugin(String pluginFileName,XmlElement definition)
	{
		super(pluginFileName,definition);
		
		buildForm();		
	}
	
	public void initialise() {
	}

	public XmlElement getMenu() {
		XmlElement xMenu = XappMenuFactory.getMenuDefinition("Settings");
		XappMenuFactory.addMenuItem(xMenu,"Proxy Settings","showSetProxy");
		
		return xMenu;
	}

	public XmlElement getActions() {
		XmlElement xActions = XappPluginFactory.getActionsDefinition();
		XappPluginFactory.addAction(this,xActions,"showSetProxy");
		XappPluginFactory.addAction(this,xActions,"setProxy");
		return xActions;
	}

	public XmlElement getData()
	{
		return form.getData();
	}
	
	public void setData(XmlElement data) {
		if(data!=null)
		{
			form.setData(data);
			setProxy();
		}
	}
	
	public void showSetProxy()
	{
		frame.show();
	}
	
	public void setProxy()
	{
		XmlElement data = getData();
		
		Properties systemSettings = System.getProperties();

		if(data.getElementByName("useProxy").getValue().equals("true"))
		{
			systemSettings.put("proxySet", "true");
			systemSettings.put("proxyHost", data.getElementByName("host").getValue());
			systemSettings.put("proxyPort", data.getElementByName("port").getValue());
		}
		else
		{
			systemSettings.put("proxySet", "false");			
		}
		
		frame.hide();
	}
}
