package org.one.stone.soup.xapp.plugins;

import javax.swing.JFrame;

import org.one.stone.soup.xapp.XappComponentStore;
import org.one.stone.soup.xapp.XappPlugin;
import org.one.stone.soup.xapp.XappRootApplication;
import org.one.stone.soup.xapp.components.form.XForm;
import org.one.stone.soup.xapp.containers.XappFrame;
import org.one.stone.soup.xapp.factories.XappMenuFactory;
import org.one.stone.soup.xapp.factories.XappPluginFactory;
import org.one.stone.soup.xml.XmlElement;

public class RegExpPlugin extends XappPlugin{
	
	public RegExpPlugin(String pluginFileName,XmlElement definition)
	{
		super(pluginFileName,definition);
		
		buildForm();
	}
	
	public void initialise()
	{
	}

	public XmlElement getMenu() {
		XmlElement xMenu = XappMenuFactory.getMenuDefinition("Tools");
		XappMenuFactory.addMenuItem(xMenu,"Test Regular Expression","showRegExp");
		
		return xMenu;
	}

	public XmlElement getActions() {
		XmlElement xActions = XappPluginFactory.getActionsDefinition();
		XappPluginFactory.addAction(this,xActions,"showRegExp");
		XappPluginFactory.addAction(this,xActions,"testRegExp");
		
		return xActions;
	}

	public XmlElement getData()
	{
		return form.getData();
	}
	
	public void setData(XmlElement data) {
		form.setData(data);
	}
	
	public void showRegExp()
	{
		frame.show();
	}
	
	public void testRegExp()
	{
		XmlElement data = form.getData();
		String testA = data.getElementByName("testA").getValue();
		String testB = data.getElementByName("testB").getValue();
		String expression = data.getElementByName("expression").getValue();
		
		boolean passA = testA.matches(expression);
		boolean passB = testB.matches(expression);
		
		data.getElementByName("passA").setValue(""+passA,0);
		data.getElementByName("passB").setValue(""+passB,0);
		
		form.setData(data);
	}
}
