package org.one.stone.soup.xapp.swing.components;

import java.awt.Dimension;
import java.awt.event.ActionListener;

import javax.swing.JProgressBar;
import javax.swing.border.BevelBorder;
import javax.swing.border.SoftBevelBorder;

import org.one.stone.soup.xapp.components.XappProgressBar;

public class XappSwingProgressBar extends JProgressBar implements
		XappProgressBar {

	public XappSwingProgressBar()
	{
		setStringPainted(true);
		setBorder( new SoftBevelBorder(BevelBorder.RAISED) );
	}
	
	public void setOrientation(String orientation) {
		int orientationValue = JProgressBar.HORIZONTAL;

		if(orientation!=null && orientation.equals("vertical"))
		{
			orientationValue = JProgressBar.VERTICAL;
		}
		
		setOrientation(orientationValue);
	}

	public void setSize(int size) {
		if(getOrientation()==JProgressBar.HORIZONTAL)
		{
			setMinimumSize( new Dimension(getHeight(),size) );
		}
		else
		{
			setMinimumSize( new Dimension(size,getWidth()) );
		}
	}

	public void addActionListener(ActionListener actionListener) {
		// TODO Auto-generated method stub
		
	}

	public void setTip(String toolTip) {
		setToolTipText(toolTip);
		
	}

	public void setTitle(String title) {
		if( title.length()==0 )
		{
			setStringPainted(false);
			setString(title);
		}
		else
		{
			setString(title);
		}
	}

	public String getData() {
		return ""+getValue();
	}

	public void setData(String value) {
		if( value==null || value.length()==0 )
		{
			return;
		}
		setValue(Integer.parseInt(value));
		
	}

	public void setEditable(boolean state) {
		// TODO Auto-generated method stub
		
	}

	public void setMaximum(String value) {
		if(value==null || value.length()==0)
		{
			return;
		}
		setMaximum( Integer.parseInt(value) );
	}

	public void setMinimum(String value) {
		if(value==null || value.length()==0)
		{
			return;
		}
		setMinimum( Integer.parseInt(value) );
	}
}
