package org.one.stone.soup.xapp.swing.components;

import java.lang.reflect.Method;

import javax.swing.JDialog;

import org.one.stone.soup.xapp.components.compound.XappSplashPage;
import org.one.stone.soup.xml.XmlElement;

public class XappSwingSplashPage extends JDialog implements Runnable, XappSplashPage{

	private boolean running = false;
	private boolean canDispose = false;

public XappSwingSplashPage(XmlElement xSplash) {
	super();
	initialize(xSplash);
}
private void initialize(XmlElement xSplash)
{
	try{
		Method method = this.getClass().getMethod("setUndecorated",new Class[]{boolean.class});
		method.invoke( this,new Object[]{new Boolean(true)} );
	}
	catch(Throwable e)
	{
		e.printStackTrace();
		System.out.println("SplashPage.setUndecorated not available in JVM");
	}

	getContentPane().add( new XSwingForm(xSplash) );

	doLayout();
	pack();
	setResizable(false);

	setLocation(100,100);

	new Thread(this,"splash timer").start();

	show();
}

/* (non-Javadoc)
 * @see org.one.stone.soup.xapp.components.compound.XappSplashPage#dispose()
 */
public void dispose()
{
	new Thread(this,"splash disposer").start();
}

public void run()
{
	if(running==false)
	{
		waitUntilCanDispose();
	}
	else
	{
		while(canDispose==false)
		{
			try{ Thread.sleep(100); }catch(Exception e){}			
		}
		super.dispose();
	}
}

/* (non-Javadoc)
 * @see org.one.stone.soup.xapp.components.compound.XappSplashPage#waitUntilCanDispose()
 */
public void waitUntilCanDispose()
{
	running = true;
	try{ Thread.sleep(5000); }catch(Exception e){}
	canDispose=true;
}
}
