package org.one.stone.soup.xapp.templates;

import org.one.stone.soup.xml.XmlElement;
import org.one.stone.soup.xml.XmlParseException;
import org.one.stone.soup.xml.XmlParser;

public class XappSchemeToXappThemeConverter implements
		XappThemeTemplateController {

	public static XmlElement convert(XmlElement scheme)
	{
		XappSchemeToXappThemeConverter controller = new XappSchemeToXappThemeConverter(scheme);

		XappThemeTemplate template = new XappThemeTemplate(controller);
		
		StringBuffer data = new StringBuffer();
		while(!template.isFinished())
		{
			data.append(template.process());
		}
		
		XmlParser parser = new XmlParser();
		try{
			return parser.parseElement( data.toString() );
		}
		catch(XmlParseException pe)
		{
			pe.printStackTrace();
		}
		
		return null;
	}
	
	private XmlElement scheme;
	
	public XappSchemeToXappThemeConverter(XmlElement scheme)
	{
		this.scheme = scheme;
	}
	
	public String getGuiFont() {
		return getFontValue("gui");
	}

	private String getFontValue(String name)
	{
		String data = " face=\""+scheme.getElementByName(name+"FontFace").getValue()+"\" ";
		data += "style=\""+scheme.getElementByName(name+"FontStyle").getValue()+"\" ";
		data += "size=\""+scheme.getElementByName(name+"FontSize").getValue()+"\"";
		return data;
	}
	
	public String getTextFont() {
		return getFontValue("text");
	}

	public String getHighlightColor() {
		return scheme.getElementByName("highlightColor").getValue();
	}

	public String getSelectedColor() {
		return scheme.getElementByName("selectedColor").getValue();
	}

	public String getBackgroundColor() {
		return scheme.getElementByName("backgroundColor").getValue();
	}

	public String getBlackColor() {
		return scheme.getElementByName("blackColor").getValue();
	}

	public String getTitleFont() {
		return getFontValue("title");
	}

	public String getForegroundColor() {
		return scheme.getElementByName("foregroundColor").getValue();
	}

	public String getShadowColor() {
		return scheme.getElementByName("shadowColor").getValue();
	}

	public String getDisabledColor() {
		return scheme.getElementByName("disabledColor").getValue();
	}

	public String getMenuBackgroundColor() {
		return scheme.getElementByName("menuBackgroundColor").getValue();
	}

	public String getMenuForegroundColor() {
		return scheme.getElementByName("menuForegroundColor").getValue();
	}	
	
	public String getTextColor() {
		return scheme.getElementByName("textColor").getValue();
	}

	public String getWindowBackgroundColor() {
		return scheme.getElementByName("windowBackgroundColor").getValue();
	}

}
