package org.one.stone.soup.xml;

import java.io.File;
import java.io.InputStream;
import java.util.Hashtable;

import org.one.stone.soup.file.FileHelper;
import org.one.stone.soup.stringhelper.StringArrayHelper;
import org.one.stone.soup.stringhelper.StringGenerator;
import org.one.stone.soup.stringhelper.StringParser;

public class XmlDOCTYPEParser implements XmlTagParser
{
	private XmlParser parser;
	private String root;
	private String name;
	private String data;
	
	public Hashtable getEntities()
	{
		Hashtable table = new Hashtable();
		
		String[] entities = StringArrayHelper.parseFields(data,'>');
		for(int loop=0;loop<entities.length;loop++)
		{
			entities[loop] = entities[loop].trim();
			if(entities[loop].indexOf("<!ENTITY")!=0)
			{
				continue;
			}
			entities[loop] = entities[loop].substring(9);
			String[] parts = StringArrayHelper.parseFields( entities[loop],' ');
			parts = StringArrayHelper.removeEmptyStrings(parts);
			if(parts[1].equals("SYSTEM"))
			{
				try{
					String fileName = StringParser.getInside(entities[loop],'\"','\"');
					if( fileName.indexOf("file:")==0 )
					{
						fileName = fileName.substring(5);
					}
					
					String fileData = FileHelper.readFile( root+"/"+fileName );
					fileData = "<data>"+fileData+"</data>";
					XmlParser parser = new XmlParser();
					parser.setCurrentFileName( root+"/"+fileName );
					XmlDocument element = parser.parseDocument(fileData);
					
					fileData="";
					for(int loopE=0;loopE<element.getElementCount();loopE++)
					{
						fileData += element.getElementByIndex(loopE).toXml(true,false)+"\n";
					}
					
					table.put(parts[0],fileData);
				}
				catch(Exception e)
				{
					e.printStackTrace();
				}

			}
			else
			{
				table.put( parts[0],StringParser.getInside(entities[loop],'\"','\"') );
			}
						
		}
		
		return table;
	}
	
	public XmlDocument embedEnitities(XmlElement target)
	{
		try{
			String data = FileHelper.readFile( parser.getCurrentFileName() );
			data = StringGenerator.generateStringWithMask(data,getEntities());
			
			return parser.parseDocument(data);
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
		return null;
	}
	
	public boolean startMatch(StringBuffer data)
	{
		if(data.length()==8 && data.toString().equals("!DOCTYPE"))
		{
			return true;
		}
		return false;
	}
	
	public boolean parseTag(XmlParser parser, String rawTag, XmlDocument doc,
			XmlElement currentElement, InputStream iStream)
			throws XmlParseException {
		
		if( rawTag.length()>=8 && rawTag.substring(0,8).equals("!DOCTYPE") )
		{	
			
			try{
				int in = iStream.read();
				StringBuffer buffer = new StringBuffer( rawTag.substring(8) );

				while(in !=-1)
				{
					if(in=='[')
					{
						break;
					}
					buffer.append((char)in);
					in = iStream.read();
				}
				
				name=buffer.toString().trim();
				
				buffer = new StringBuffer( rawTag.substring(8) );
				in = iStream.read();
				while(in !=-1)
				{
					if(in==']')
					{
						break;
					}
					buffer.append((char)in);
					
					in = iStream.read();
				}
				
				data = buffer.toString();
				
				while(in !=-1)
				{
					if(in=='>')
					{
						break;
					}
					
					in = iStream.read();
				}	
			}
			catch(Exception e)
			{
				throw new XmlParseException(-1,-1);
			}
			
			root = new File(parser.getCurrentFileName()).getAbsoluteFile().getParentFile().getAbsolutePath();
			this.parser = parser;
			
			return true;
		}
		
		return false;
	}

	public String getData() {
		return data;
	}

	public String getName() {
		return name;
	}

}

