package org.one.stone.soup.xml.helper;

import org.one.stone.soup.xml.*;

/*
 * Wet-Wired.com Xml Helpers Version Date 25-Aug-2004
 *
 * Copyright 2000-2001 by Wet-Wired.com Ltd.,
 * Portsmouth England
 * This software is OSI Certified Open Source Software
 * This software is covered by an OSI approved open source licence
 * which can be found at http://www.onestonesoup.org/OSSLicense.html
 */

/**
 * @author nikcross
 *
 */

// TODO
public class XmlSort {
/**
 * XmlSort constructor comment.
 */
private XmlSort() {
	super();
}
/**
 * Insert the method's description here.
 * Creation date: (13/06/03 09:39:01)
 * @return int
 * @param a java.lang.String
 * @param b java.lang.String
 */
private static int compare(String a, String b) {

	a = a.toUpperCase();
	b = b.toUpperCase();

	int subjectSize = a.length();
	int targetSize = b.length();

	for(int loop=0;loop<subjectSize;loop++)
	{
		if(loop>=targetSize)
		{
			return 1;
		}

		if(a.charAt(loop)==b.charAt(loop))
		{
			continue;
		}
		else
		{
			if(a.charAt(loop)>b.charAt(loop))
			{
				return 1;
			}
			else
			{
				return -1;
			}
		}
	}

	if(targetSize>subjectSize)
		return -1;

	return 0;
}
/**
 * Insert the method's description here.
 * Creation date: (13/06/03 09:25:01)
 * @param source org.one.stone.soup.xml.XmlElement
 * @param attributeName java.lang.String
 */
public static void sortElement(XmlElement source, String attributeName)
{
	sortElement(source,attributeName,false);
}
public static void sortElement(XmlElement source, String attributeName,boolean recursive)
{
	XmlElement temp = new XmlElement("temp");

	String[] value = new String[source.getElementCount()];
	int[] index = new int[source.getElementCount()];
	boolean[] sorted = new boolean[source.getElementCount()];

	int count = 0;
	while(source.getElementCount()>0)
	{
		XmlElement element = source.getElementByIndex(0);
		source.removeChild( source.getElementByIndex(0) );
		temp.addChild(element);

		if(element.getAttributeValueByName(attributeName)!=null)
		{
			value[count] = element.getAttributeValueByName(attributeName);
		}
		else
		{
			value[count]="";
		}
		sorted[count]=false;
		index[count]=0;

		count++;
	}

	for(int loop=0;loop<index.length;loop++)
	{
		int found = -1;
		for(int loop2=0;loop2<index.length;loop2++)
		{
			if(sorted[loop2])
			{
				continue;
			}

			if(found==-1 || compare(value[loop2],value[found])==-1)
			{
				found = loop2;
			}
		}
		index[loop] = found;
		sorted[found]=true;
	}

	for(int loop=0;loop<index.length;loop++)
	{
		if(recursive)
		{
			sortElement( temp.getElementByIndex(index[loop]),attributeName );
		}

		source.addChild( temp.getElementByIndex(index[loop]) );
	}
}
}
